/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeAWSClusters implements AWSClusterInterface
type FakeAWSClusters struct {
	Fake *FakeInfrastructureV1beta2
	ns   string
}

var awsclustersResource = schema.GroupVersionResource{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta2", Resource: "awsclusters"}

var awsclustersKind = schema.GroupVersionKind{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta2", Kind: "AWSCluster"}

// Get takes name of the aWSCluster, and returns the corresponding aWSCluster object, and an error if there is any.
func (c *FakeAWSClusters) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta2.AWSCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(awsclustersResource, c.ns, name), &v1beta2.AWSCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSCluster), err
}

// List takes label and field selectors, and returns the list of AWSClusters that match those selectors.
func (c *FakeAWSClusters) List(ctx context.Context, opts v1.ListOptions) (result *v1beta2.AWSClusterList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(awsclustersResource, awsclustersKind, c.ns, opts), &v1beta2.AWSClusterList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta2.AWSClusterList{ListMeta: obj.(*v1beta2.AWSClusterList).ListMeta}
	for _, item := range obj.(*v1beta2.AWSClusterList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested aWSClusters.
func (c *FakeAWSClusters) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(awsclustersResource, c.ns, opts))

}

// Create takes the representation of a aWSCluster and creates it.  Returns the server's representation of the aWSCluster, and an error, if there is any.
func (c *FakeAWSClusters) Create(ctx context.Context, aWSCluster *v1beta2.AWSCluster, opts v1.CreateOptions) (result *v1beta2.AWSCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(awsclustersResource, c.ns, aWSCluster), &v1beta2.AWSCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSCluster), err
}

// Update takes the representation of a aWSCluster and updates it. Returns the server's representation of the aWSCluster, and an error, if there is any.
func (c *FakeAWSClusters) Update(ctx context.Context, aWSCluster *v1beta2.AWSCluster, opts v1.UpdateOptions) (result *v1beta2.AWSCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(awsclustersResource, c.ns, aWSCluster), &v1beta2.AWSCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSCluster), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeAWSClusters) UpdateStatus(ctx context.Context, aWSCluster *v1beta2.AWSCluster, opts v1.UpdateOptions) (*v1beta2.AWSCluster, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(awsclustersResource, "status", c.ns, aWSCluster), &v1beta2.AWSCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSCluster), err
}

// Delete takes name of the aWSCluster and deletes it. Returns an error if one occurs.
func (c *FakeAWSClusters) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(awsclustersResource, c.ns, name, opts), &v1beta2.AWSCluster{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeAWSClusters) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(awsclustersResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta2.AWSClusterList{})
	return err
}

// Patch applies the patch and returns the patched aWSCluster.
func (c *FakeAWSClusters) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(awsclustersResource, c.ns, name, pt, data, subresources...), &v1beta2.AWSCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSCluster), err
}
